/******************************
 * インターフェイスの列挙とバインドの例
 ******************************/

#include <stdio.h>
#include <string.h>
#include <wayland-client.h>

struct wl_compositor *g_compositor = NULL;


/* 利用可能になった時 */

static void _registry_global(
	void *data,struct wl_registry *registry,
	uint32_t id,const char *interface,uint32_t version)
{
	printf("%s | id:%u | ver:%u\n", interface, id, version);

	//wl_compositor が使えるようにバインドする

	if(strcmp(interface, "wl_compositor") == 0)
		g_compositor = wl_registry_bind(registry, id, &wl_compositor_interface, 1);
}

/* 取り外された時 */

static void _registry_global_remove(void *data,struct wl_registry *registry,uint32_t id)
{

}

//wl_registry のハンドラの構造体

static const struct wl_registry_listener g_reg_listener = {
	_registry_global, _registry_global_remove
};

/* main */

int main(void)
{
	struct wl_display *display;
	struct wl_registry *reg;

	//接続

	display = wl_display_connect(NULL);
	if(!display) return 1;

	//wl_registry 取得

	reg = wl_display_get_registry(display);

	//ハンドラセット
	
	wl_registry_add_listener(reg, &g_reg_listener, NULL);

	//サーバーで処理されるまで待つ

	wl_display_roundtrip(display);

	//終了

	wl_compositor_destroy(g_compositor);
	wl_registry_destroy(reg);

	wl_display_disconnect(display);

	return 0;
}
