/* xdg-shell 対応クライアント処理 */

#ifndef _CLIENT_XDG_H_
#define _CLIENT_XDG_H_

#include <wayland-cursor.h>
#include "xdg-shell-client-protocol.h"

typedef struct _ImageBuf ImageBuf;


/*---- ClientXdg ----*/

#define CLIENT_XDG(p)  ((ClientXdg *)(p))

typedef struct _ClientXdg ClientXdg;

typedef struct
{
	struct xdg_wm_base *xdg_wm_base;

	struct wl_cursor_theme *cursor_theme;
	struct wl_cursor *cursor_default;
	struct wl_surface *cursor_surface;

	client_registry_global registry_global_xdg;
}ClientXdgData;

struct _ClientXdg
{
	Client b;
	ClientXdgData xdg;
};


ClientXdg *ClientXdg_new(int size);
void ClientXdg_destroy(ClientXdg *p);
void ClientXdg_init(ClientXdg *p,client_registry_global global);
void ClientXdg_setCursor(ClientXdg *p,uint32_t serial);

/*---- WindowXdg ----*/

typedef struct _WindowXdg WindowXdg;

struct _WindowXdg
{
	ClientXdg *client;
	struct wl_surface *surface;
	struct xdg_surface *xdg_surface;
	struct xdg_toplevel *xdg_toplevel;

	ImageBuf *img;
	uint8_t flag_configure;
};


WindowXdg *WindowXdg_createToplevel(ClientXdg *cl,int width,int height);
void WindowXdg_destroy(WindowXdg *p);
void WindowXdg_update(WindowXdg *p);

#endif
